/*
 * com/ngon/tap/ClipInfo.java
 * Victor Liu > mailto:victor@n-gon.com
 *
 * Copyright (C) 2004 Victor Liu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.ngon.tap;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.StringTokenizer;

/**
 * class ClipInfo
 */
final class ClipInfo {
    
    int clipID;
    String clipName;
    int clipLen;
    
    ClipInfo() {}
    
    ClipInfo(int clipID, String clipName, int clipLen) {
        this.clipID = clipID;
        this.clipName = clipName;
        this.clipLen = clipLen;
    }
    
    static ClipInfo parseRow(ResultSet rs) throws SQLException {
        ClipInfo ci = new ClipInfo();
        ci.clipID   = rs.getInt(1);
        ci.clipName = rs.getString(2);
        ci.clipLen  = rs.getInt(3);
        return ci;
    }
    
    static ClipInfo parseEncodedString(String s, String delim) {
        ClipInfo ci = new ClipInfo();
        StringTokenizer st = new StringTokenizer(s, delim);
        if (st.countTokens() != 3) {
            return null;
        }
        ci.clipID = Integer.parseInt(st.nextToken());
        ci.clipName = st.nextToken();
        ci.clipLen = Integer.parseInt(st.nextToken());
        return ci;
    }
    
    StringBuffer toEncodedStringBuffer(String delim) {
        return new StringBuffer().
            append(clipID).append(delim).
            append(clipName).append(delim).
            append(clipLen);
    }
}

