/*
 * com/ngon/tap/TapLinks.java
 * Victor Liu > mailto:victor@n-gon.com
 *
 * Copyright (C) 2004 Victor Liu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.ngon.tap;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Enumeration;
import java.util.Vector;

/**
 * class TapLinks
 */
final public class TapLinks {
    
    static public void main(String[] args) {
        try {
            // Init db connection.
            Class.forName("com.mysql.jdbc.Driver");
            Connection dbc = DriverManager.getConnection(
                "jdbc:mysql://localhost/c3cuts?user=victor");
            Statement stmt = dbc.createStatement();
            
            // Create prepared queries for later.
            ClusQuery queryOutOfSequence = new ClusQueryOutOfSequence(dbc);
            PreparedStatement insertLinkStmt = 
                dbc.prepareStatement(
                    "INSERT INTO mvclusterlink " +
                    "(mvcluster_id,link_mvclus_id,link_mvclus_wt) " + 
                    "VALUES (?,?,?)");
            
            ResultSet rs;
            rs = stmt.executeQuery("SELECT MAX(id) FROM mvcluster");
            rs.next();
            int maxClusID = rs.getInt(1);
            
            // Loop through all clusters.
            for (int clusID = 0; clusID <= maxClusID; clusID++) {
                rs = stmt.executeQuery(
                    ClusQuery.MVCLUSTER_QUERY + " WHERE id=" + clusID); 
                if (! rs.next()) {
                    continue;
                }
                
                Clus ref = Clus.parseRow(rs);
                System.out.println("clip: " + ref.clipID + " cluster: " +
                    ref.clusterID);
                
                // Store links.
                Vector links = queryOutOfSequence.findResults(ref);
                for (int i = 0; i < links.size(); i++) {
                    Clus c = (Clus) links.elementAt(i);
                    insertLinkStmt.setInt(1, ref.clusterID);
                    insertLinkStmt.setInt(2, c.clusterID);
                    insertLinkStmt.setInt(3, c.weight);
                    insertLinkStmt.execute();
                }
                
                // Store weightTotal.
                int wtSum = queryOutOfSequence.getResultsWeightTotal();
                stmt.executeUpdate(
                    "UPDATE mvcluster SET link_wt_sum=" + wtSum + 
                    " WHERE id=" + ref.clusterID);
            }
        } catch (Exception e) {
            System.err.println(e);
        }
    }
    
}
