#!/usr/bin/perl

###############################################################################
# Begin MAIN                                                                  #

&main;
exit;

# End of MAIN                                                                 #
###############################################################################

sub main {
    opendir(DIR, '../vid-frames/') || die "$!";
    my @files = readdir(DIR);
    my @clip_names = grep { (! /^\./) && (-d "../vid-frames/$_") } @files;
    closedir DIR;
    
    chdir '../clips';
    
    my $src_dir = '../scripts/templates';
    my @input_files = ('clip-name.+0.param', 'clip-name.+1.param', 
        'clip-segs.param');
    
    local $/; # Slurp
    for my $name (@clip_names) {
        print "$name ... ";
        mkdir "$name" unless -d "$name";
        
        my @output_files = ("$name/$name.+0.param", "$name/$name.+1.param",
            "$name/clip-segs.param");
        
        # Find last frame.
        my $last_frame =`ls -r1 ../vid-frames/$name/*.jpg | head -1`;
        $last_frame =~ s/^.+$name\.//;
        $last_frame =~ s/\.jpg$//;
        chop $last_frame;
        print " [$last_frame] ";
        
        for my $i (0..2) {
            open(IN, "<$src_dir/$input_files[$i]") or die $!;
            my $buf = <IN>;
            close(IN);
            
            $buf =~ s/clip\-name/$name/g;
            my $first_frame = ($i == 1) ? '0002' : '0001';
            $buf =~ s|\[\d{4}\-\d{4}(\+3)*\]|[$first_frame-$last_frame]|;
            
            open(OUT, ">$output_files[$i]") or die $!;
            print OUT $buf;
            close(OUT);
        }
        print "done\n";
    }
}

